unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, Spin, HamCap_TLB, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    SpinEdit1: TSpinEdit;
    CheckBox1: TCheckBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton24: TSpeedButton;
    SpeedButton25: TSpeedButton;
    SpeedButton26: TSpeedButton;
    RichEdit1: TRichEdit;
    SpeedButton27: TSpeedButton;
    SpeedButton28: TSpeedButton;
    SpeedButton29: TSpeedButton;
    SpeedButton30: TSpeedButton;
    SpeedButton31: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton22Click(Sender: TObject);
    procedure SpeedButton26Click(Sender: TObject);
    procedure SpeedButton19Click(Sender: TObject);
    procedure SpeedButton20Click(Sender: TObject);
    procedure SpeedButton21Click(Sender: TObject);
    procedure SpeedButton23Click(Sender: TObject);
    procedure SpeedButton24Click(Sender: TObject);
    procedure SpeedButton25Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton18Click(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure SpeedButton29Click(Sender: TObject);
    procedure SpeedButton27Click(Sender: TObject);
    procedure SpeedButton28Click(Sender: TObject);
    procedure SpeedButton30Click(Sender: TObject);
    procedure SpeedButton31Click(Sender: TObject);
  private
    Cap: THamCapApp;
    procedure ExitRequestEvent(Sender: TObject);
    procedure ErrorEvent(Sender: TObject);
    procedure MapChangeEvent(Sender: TObject);
    procedure ChartChangeEvent(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if SpeedButton1.Down
    then Cap := THamCapApp.Create(Self)
    else FreeAndNil(Cap);

  SpeedButton1.Down := Cap <> nil;
  if SpeedButton1.Down then
    begin
    Caption := Format('%x', [Cap.Version]);
    Cap.OnExitRequest := ExitRequestEvent;
    Cap.OnError := ErrorEvent;
    Cap.OnMapChange := MapChangeEvent;
    Cap.OnChartChange := ChartChangeEvent;
    end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Cap.Visible := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
Cap.left := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
cap.top := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
cap.page := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
cap.homelat := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
cap.homelon := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
cap.dxlat := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
cap.dxlon := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
cap.MapStyle := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
begin
cap.MapResolution := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton12Click(Sender: TObject);
begin
cap.ShowMuf := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton13Click(Sender: TObject);
begin
cap.ShowSun := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton14Click(Sender: TObject);
begin
cap.ShowPath := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton15Click(Sender: TObject);
begin
cap.DxCall := Edit1.Text;
end;

procedure TForm1.SpeedButton22Click(Sender: TObject);
begin
cap.LongPath := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton26Click(Sender: TObject);
begin
cap.UseKp := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton19Click(Sender: TObject);
begin
cap.atlason := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton20Click(Sender: TObject);
begin
cap.IonoProbeOn := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton21Click(Sender: TObject);
begin
cap.RealtimeClock := CheckBox1.Checked;
end;

procedure TForm1.SpeedButton23Click(Sender: TObject);
begin
cap.Ssn := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton24Click(Sender: TObject);
begin
cap.kp := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton25Click(Sender: TObject);
begin
cap.txpower := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton17Click(Sender: TObject);
begin
cap.hour := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton18Click(Sender: TObject);
begin
cap.band := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton16Click(Sender: TObject);
begin
cap.SetYearMonth(2000 + SpinEdit1.Value, SpinEdit1.Value);
end;


procedure TForm1.ChartChangeEvent(Sender: TObject);
begin
  RichEdit1.Lines.Add('>> ChartChangeEvent');
end;

procedure TForm1.ExitRequestEvent(Sender: TObject);
begin
  FreeAndNil(Cap);
  SpeedButton1.Down := false;
  RichEdit1.Lines.Add('>> ExitRequestEvent');
end;

procedure TForm1.MapChangeEvent(Sender: TObject);
begin
  RichEdit1.Lines.Add('>> MapChangeEvent');
end;

procedure TForm1.ErrorEvent(Sender: TObject);
begin
  RichEdit1.Lines.Add('>> ErrorEvent');
end;

procedure TForm1.SpeedButton29Click(Sender: TObject);
const
  B: array[boolean] of string = ('false', 'true');
begin
  Richedit1.lines.clear;
  Richedit1.lines.Add(Format('Version: %x', [cap.version]));
  Richedit1.lines.Add(Format('YearMonth: %s', [cap.YearMonth]));
  Richedit1.lines.Add(Format('Visible: %s', [B[cap.Visible]]));
  Richedit1.lines.Add(Format('Left: %d', [cap.Left]));
  Richedit1.lines.Add(Format('Top: %d', [cap.Top]));
  Richedit1.lines.Add(Format('Page: %d', [cap.Page]));
  Richedit1.lines.Add(Format('HomeLat: %f', [cap.HomeLat]));
  Richedit1.lines.Add(Format('HomeLon: %f', [cap.HomeLon]));
  Richedit1.lines.Add(Format('DxLat: %f', [cap.DxLat]));
  Richedit1.lines.Add(Format('DxLon: %f', [cap.DxLon]));
  Richedit1.lines.Add(Format('MapStyle: %d', [cap.MapStyle]));
  Richedit1.lines.Add(Format('MapResolution: %d', [cap.MapResolution]));
  Richedit1.lines.Add(Format('ShowMuf: %s', [B[cap.ShowMuf]]));
  Richedit1.lines.Add(Format('ShowSun: %s', [B[cap.ShowSun]]));

  Richedit1.lines.Add(Format('ShowPath: %s', [B[cap.ShowPath]]));
  Richedit1.lines.Add(Format('DxCall: %s', [cap.DxCall]));
  Richedit1.lines.Add(Format('LongPath: %s', [B[cap.LongPath]]));
  Richedit1.lines.Add(Format('Ssn: %d', [cap.Ssn]));
  Richedit1.lines.Add(Format('Kp: %d', [cap.Kp]));
  Richedit1.lines.Add(Format('TxPower: %d', [cap.TxPower]));
  Richedit1.lines.Add(Format('UseKp: %s', [B[cap.UseKp]]));
  Richedit1.lines.Add(Format('Hour: %d', [cap.Hour]));
  Richedit1.lines.Add(Format('Band: %d', [cap.Band]));
  Richedit1.lines.Add(Format('AtlasOn: %s', [B[cap.AtlasOn]]));
  Richedit1.lines.Add(Format('IonoProbeOn: %s', [B[cap.IonoProbeOn]]));
  Richedit1.lines.Add(Format('RealtimeClock: %s', [B[cap.RealtimeClock]]));
end;

procedure TForm1.SpeedButton27Click(Sender: TObject);
begin
cap.PredictPoint;
end;

procedure TForm1.SpeedButton28Click(Sender: TObject);
begin
cap.PredictArea;
end;

procedure TForm1.SpeedButton30Click(Sender: TObject);
begin
cap.SaveChartImage('d:\a.bmp');
end;

procedure TForm1.SpeedButton31Click(Sender: TObject);
begin
cap.SaveMapImage('d:\a.bmp');
end;

end.

